//
// <LIC_AMD_STD>
// Copyright (C) <years> Advanced Micro Devices, Inc.  All Rights Reserved.
// </LIC_AMD_STD>
//
// <CTL_AMD_STD>
// </CTL_AMD_STD>
//
// <DOC_AMD_STD>
// DirectDraw definitions.
// </DOC_AMD_STD>
//

#ifndef __LX_DRAW_H
#define __LX_DRAW_H

// DirectDraw Base routines.
//
DWORD DdCanCreateSurface(PDD_CANCREATESURFACEDATA lpCanCreateSurface);
DWORD DdCreateSurface(PDD_CREATESURFACEDATA lpCreateSurface);
DWORD DdDestroySurface(PDD_DESTROYSURFACEDATA  lpDestroySurface);
DWORD DdGetBltStatus(PDD_GETBLTSTATUSDATA lpGetBltStatus);
DWORD DdGetFlipStatus(PDD_GETFLIPSTATUSDATA lpGetFlipStatus);
DWORD DdLock(PDD_LOCKDATA lpLock);
DWORD DdMapMemory(PDD_MAPMEMORYDATA lpMapMemory);
DWORD DdSetColorKey(PDD_SETCOLORKEYDATA lpSetColorKey);
DWORD DdSetOverlayPosition(PDD_SETOVERLAYPOSITIONDATA lpSetOverlayPosition);
DWORD DdUpdateOverlay(PDD_UPDATEOVERLAYDATA lpUpdateOverlay);
DWORD DdWaitForVerticalBlank(PDD_WAITFORVERTICALBLANKDATA lpWaitForVerticalBlank);
DWORD DdBlt(PDD_BLTDATA lpBlt);
DWORD DdFlip(PDD_FLIPDATA lpFlip);
DWORD DdGetScanLine (PDD_GETSCANLINEDATA pGetScanLine);
DWORD DdGetDriverInfo(PDD_GETDRIVERINFODATA lpData);

// Video Helper routines.
//
BOOL  SetChromaKey(PDEV *ppdev, DWORD Key, DWORD Bpp, int graphics);
BOOL  SetVideoPosition(PDEV *ppdev, int scale);

// VPE Routines
//
DWORD DdVideoPortCanCreate (PDD_CANCREATEVPORTDATA lpInput);
DWORD DdVideoPortCreate(PDD_CREATEVPORTDATA lpInput);
DWORD DdVideoPortFlip (PDD_FLIPVPORTDATA lpInput);
DWORD DdVideoPortGetFlipStatus (PDD_GETVPORTFLIPSTATUSDATA lpInput);
DWORD DdVideoPortGetBandwidth (PDD_GETVPORTBANDWIDTHDATA lpInput);
DWORD DdVideoPortGetInputFormats (PDD_GETVPORTINPUTFORMATDATA lpInput);
DWORD DdVideoPortGetOutputFormats (PDD_GETVPORTOUTPUTFORMATDATA lpInput);
DWORD DdVideoPortGetConnectInfo (PDD_GETVPORTCONNECTDATA lpInput);
DWORD DdVideoPortDestroy(PDD_DESTROYVPORTDATA lpInput);
DWORD DdVideoPortUpdate (PDD_UPDATEVPORTDATA lpInput);
DWORD DdVideoPortWaitForSync (PDD_WAITFORVPORTSYNCDATA lpInput);
DWORD DdVideoPortGetSignalStatus(PDD_GETVPORTSIGNALDATA lpInput);
DWORD DdVideoPortGetField(PDD_GETVPORTFIELDDATA lpInput);
DWORD DdVideoPortGetLine(PDD_GETVPORTLINEDATA lpInput);
DWORD DdVideoPortGetColorControl(PDD_VPORTCOLORDATA lpInput);
DWORD DdSyncVideoPortData(PDD_SYNCVIDEOPORTDATA  lpSyncVideoPort);
DWORD DdSyncSurfaceData(PDD_SYNCSURFACEDATA  lpSyncSurface);
DWORD DdSetExclusiveMode (PDD_SETEXCLUSIVEMODEDATA lpSetExclusiveMode);
DWORD DdGetAvailDriverMemory (PDD_GETAVAILDRIVERMEMORYDATA lpGetAvailDriverMemory);

// YUV DEFINES
// Definition used to indicate that a surface is an overlay
// surface.  The lower bits are also used to hold the format
// of the video surface.

#define DD_RESERVED_VIDEO_SURFACE   0x40000000
#define DD_RESERVED_420_UFIRST      0x80000000

#define calculateOffset(offset, x, y, surf)         \
{                                                   \
	offset  = (y * surf->lPitch) + surf->fpVidMem;  \
	offset += (x << ppdev->cPelSize);               \
}

// PALETTE CONTROL DEFINITIONS
//
#define COLOR_RANGE    255
#define COLOR_MID      128
#define COLOR_DEFAULT  128

#define MODE_GAMMA      0
#define MODE_BRIGHT     1
#define MODE_CONTRAST   2
#define MODE_HUE        3

// DRIVER SUPPORTED FOURCC CODES
//
#define FOURCC_YUY2   0x32595559
#define FOURCC_YVYU   0x55595659
#define FOURCC_UYVY   0x59565955
#define FOURCC_YV12   0x32315659
#define FOURCC_I420   0x30323449
#define FOURCC_IYUV   0x56555949

#endif