//
// <LIC_AMD_STD>
// Copyright (C) <years> Advanced Micro Devices, Inc.  All Rights Reserved.
// </LIC_AMD_STD>
//
// <CTL_AMD_STD>
// </CTL_AMD_STD>
//
// <DOC_AMD_STD>
// Global ROP definitions.
// </DOC_AMD_STD>
//

#ifndef __LX_ROP4_H
#define __LX_ROP4_H

#define LX_ROP_PAT 1
#define LX_ROP_SRC 2
#define LX_ROP_DST 4

unsigned char rop4Flags[256] =
{
    0,                                          // 00 - 0
    LX_ROP_PAT | LX_ROP_SRC | LX_ROP_DST,       // 01 -
    LX_ROP_PAT | LX_ROP_SRC | LX_ROP_DST,       // 02 -
    LX_ROP_PAT | LX_ROP_SRC,                    // 03 - PSon
    LX_ROP_PAT | LX_ROP_SRC | LX_ROP_DST,       // 04 -
    LX_ROP_PAT | LX_ROP_DST,                    // 05 - DPon
    LX_ROP_PAT | LX_ROP_SRC | LX_ROP_DST,       // 06 -
    LX_ROP_PAT | LX_ROP_SRC | LX_ROP_DST,       // 07 -
    LX_ROP_PAT | LX_ROP_SRC | LX_ROP_DST,       // 08 -
    LX_ROP_PAT | LX_ROP_SRC | LX_ROP_DST,       // 09 -
    LX_ROP_PAT | LX_ROP_DST,                    // 0A - DPna
    LX_ROP_PAT | LX_ROP_SRC | LX_ROP_DST,       // 0B -
    LX_ROP_PAT | LX_ROP_SRC,                    // 0C - SPna
    LX_ROP_PAT | LX_ROP_SRC | LX_ROP_DST,       // 0D -
    LX_ROP_PAT | LX_ROP_SRC | LX_ROP_DST,       // 0E -
    LX_ROP_PAT,                                 // 0F - Pn

    LX_ROP_PAT | LX_ROP_SRC | LX_ROP_DST,       // 10 -
    LX_ROP_SRC | LX_ROP_DST,                    // 11 - DSon
    LX_ROP_PAT | LX_ROP_SRC | LX_ROP_DST,       // 12 -
    LX_ROP_PAT | LX_ROP_SRC | LX_ROP_DST,       // 13 -
    LX_ROP_PAT | LX_ROP_SRC | LX_ROP_DST,       // 14 -
    LX_ROP_PAT | LX_ROP_SRC | LX_ROP_DST,       // 15 -
    LX_ROP_PAT | LX_ROP_SRC | LX_ROP_DST,       // 16 -
    LX_ROP_PAT | LX_ROP_SRC | LX_ROP_DST,       // 17 -
    LX_ROP_PAT | LX_ROP_SRC | LX_ROP_DST,       // 18 -
    LX_ROP_PAT | LX_ROP_SRC | LX_ROP_DST,       // 19 -
    LX_ROP_PAT | LX_ROP_SRC | LX_ROP_DST,       // 1A -
    LX_ROP_PAT | LX_ROP_SRC | LX_ROP_DST,       // 1B -
    LX_ROP_PAT | LX_ROP_SRC | LX_ROP_DST,       // 1C -
    LX_ROP_PAT | LX_ROP_SRC | LX_ROP_DST,       // 1D -
    LX_ROP_PAT | LX_ROP_SRC | LX_ROP_DST,       // 1E -
    LX_ROP_PAT | LX_ROP_SRC | LX_ROP_DST,       // 1F -

    LX_ROP_PAT | LX_ROP_SRC | LX_ROP_DST,       // 20 -
    LX_ROP_PAT | LX_ROP_SRC | LX_ROP_DST,       // 21 -
    LX_ROP_SRC | LX_ROP_DST,                    // 22 - DSna
    LX_ROP_PAT | LX_ROP_SRC | LX_ROP_DST,       // 23 -
    LX_ROP_PAT | LX_ROP_SRC | LX_ROP_DST,       // 24 -
    LX_ROP_PAT | LX_ROP_SRC | LX_ROP_DST,       // 25 -
    LX_ROP_PAT | LX_ROP_SRC | LX_ROP_DST,       // 26 -
    LX_ROP_PAT | LX_ROP_SRC | LX_ROP_DST,       // 27 -
    LX_ROP_PAT | LX_ROP_SRC | LX_ROP_DST,       // 28 -
    LX_ROP_PAT | LX_ROP_SRC | LX_ROP_DST,       // 29 -
    LX_ROP_PAT | LX_ROP_SRC | LX_ROP_DST,       // 2A -
    LX_ROP_PAT | LX_ROP_SRC | LX_ROP_DST,       // 2B -
    LX_ROP_PAT | LX_ROP_SRC | LX_ROP_DST,       // 2C -
    LX_ROP_PAT | LX_ROP_SRC | LX_ROP_DST,       // 2D -
    LX_ROP_PAT | LX_ROP_SRC | LX_ROP_DST,       // 2E -
    LX_ROP_PAT | LX_ROP_SRC | LX_ROP_DST,       // 2F -

    LX_ROP_PAT | LX_ROP_SRC,                    // 30 - PSna
    LX_ROP_PAT | LX_ROP_SRC | LX_ROP_DST,       // 31 -
    LX_ROP_PAT | LX_ROP_SRC | LX_ROP_DST,       // 32 -
    LX_ROP_SRC,                                 // 33 - Sn
    LX_ROP_PAT | LX_ROP_SRC | LX_ROP_DST,       // 34 -
    LX_ROP_PAT | LX_ROP_SRC | LX_ROP_DST,       // 35 -
    LX_ROP_PAT | LX_ROP_SRC | LX_ROP_DST,       // 36 -
    LX_ROP_PAT | LX_ROP_SRC | LX_ROP_DST,       // 37 -
    LX_ROP_PAT | LX_ROP_SRC | LX_ROP_DST,       // 38 -
    LX_ROP_PAT | LX_ROP_SRC | LX_ROP_DST,       // 39 -
    LX_ROP_PAT | LX_ROP_SRC | LX_ROP_DST,       // 3A -
    LX_ROP_PAT | LX_ROP_SRC | LX_ROP_DST,       // 3B -
    LX_ROP_PAT | LX_ROP_SRC,                    // 3C - PSx
    LX_ROP_PAT | LX_ROP_SRC | LX_ROP_DST,       // 3D -
    LX_ROP_PAT | LX_ROP_SRC | LX_ROP_DST,       // 3E -
    LX_ROP_PAT | LX_ROP_SRC,                    // 3F - PSan

    LX_ROP_PAT | LX_ROP_SRC | LX_ROP_DST,       // 40 -
    LX_ROP_PAT | LX_ROP_SRC | LX_ROP_DST,       // 41 -
    LX_ROP_PAT | LX_ROP_SRC | LX_ROP_DST,       // 42 -
    LX_ROP_PAT | LX_ROP_SRC | LX_ROP_DST,       // 43 -
    LX_ROP_SRC | LX_ROP_DST,                    // 44 - SDna
    LX_ROP_PAT | LX_ROP_SRC | LX_ROP_DST,       // 45 -
    LX_ROP_PAT | LX_ROP_SRC | LX_ROP_DST,       // 46 -
    LX_ROP_PAT | LX_ROP_SRC | LX_ROP_DST,       // 47 -
    LX_ROP_PAT | LX_ROP_SRC | LX_ROP_DST,       // 48 -
    LX_ROP_PAT | LX_ROP_SRC | LX_ROP_DST,       // 49 -
    LX_ROP_PAT | LX_ROP_SRC | LX_ROP_DST,       // 4A -
    LX_ROP_PAT | LX_ROP_SRC | LX_ROP_DST,       // 4B -
    LX_ROP_PAT | LX_ROP_SRC | LX_ROP_DST,       // 4C -
    LX_ROP_PAT | LX_ROP_SRC | LX_ROP_DST,       // 4D -
    LX_ROP_PAT | LX_ROP_SRC | LX_ROP_DST,       // 4E -
    LX_ROP_PAT | LX_ROP_SRC | LX_ROP_DST,       // 4F -

    LX_ROP_PAT | LX_ROP_DST,                    // 50 - PDna
    LX_ROP_PAT | LX_ROP_SRC | LX_ROP_DST,       // 51 -
    LX_ROP_PAT | LX_ROP_SRC | LX_ROP_DST,       // 52 -
    LX_ROP_PAT | LX_ROP_SRC | LX_ROP_DST,       // 53 -
    LX_ROP_PAT | LX_ROP_SRC | LX_ROP_DST,       // 54 -
    LX_ROP_DST,                                 // 55 - Dn
    LX_ROP_PAT | LX_ROP_SRC | LX_ROP_DST,       // 56 -
    LX_ROP_PAT | LX_ROP_SRC | LX_ROP_DST,       // 57 -
    LX_ROP_PAT | LX_ROP_SRC | LX_ROP_DST,       // 58 -
    LX_ROP_PAT | LX_ROP_SRC | LX_ROP_DST,       // 59 -
    LX_ROP_PAT | LX_ROP_DST,                    // 5A - DPx
    LX_ROP_PAT | LX_ROP_SRC | LX_ROP_DST,       // 5B -
    LX_ROP_PAT | LX_ROP_SRC | LX_ROP_DST,       // 5C -
    LX_ROP_PAT | LX_ROP_SRC | LX_ROP_DST,       // 5D -
    LX_ROP_PAT | LX_ROP_SRC | LX_ROP_DST,       // 5E -
    LX_ROP_PAT | LX_ROP_DST,                    // 5F - DPan

    LX_ROP_PAT | LX_ROP_SRC | LX_ROP_DST,       // 60 -
    LX_ROP_PAT | LX_ROP_SRC | LX_ROP_DST,       // 61 -
    LX_ROP_PAT | LX_ROP_SRC | LX_ROP_DST,       // 62 -
    LX_ROP_PAT | LX_ROP_SRC | LX_ROP_DST,       // 63 -
    LX_ROP_PAT | LX_ROP_SRC | LX_ROP_DST,       // 64 -
    LX_ROP_PAT | LX_ROP_SRC | LX_ROP_DST,       // 65 -
    LX_ROP_SRC | LX_ROP_DST,                    // 66 - DSx
    LX_ROP_PAT | LX_ROP_SRC | LX_ROP_DST,       // 67 -
    LX_ROP_PAT | LX_ROP_SRC | LX_ROP_DST,       // 68 -
    LX_ROP_PAT | LX_ROP_SRC | LX_ROP_DST,       // 69 -
    LX_ROP_PAT | LX_ROP_SRC | LX_ROP_DST,       // 6A -
    LX_ROP_PAT | LX_ROP_SRC | LX_ROP_DST,       // 6B -
    LX_ROP_PAT | LX_ROP_SRC | LX_ROP_DST,       // 6C -
    LX_ROP_PAT | LX_ROP_SRC | LX_ROP_DST,       // 6D -
    LX_ROP_PAT | LX_ROP_SRC | LX_ROP_DST,       // 6E -
    LX_ROP_PAT | LX_ROP_SRC | LX_ROP_DST,       // 6F -

    LX_ROP_PAT | LX_ROP_SRC | LX_ROP_DST,       // 70 -
    LX_ROP_PAT | LX_ROP_SRC | LX_ROP_DST,       // 71 -
    LX_ROP_PAT | LX_ROP_SRC | LX_ROP_DST,       // 72 -
    LX_ROP_PAT | LX_ROP_SRC | LX_ROP_DST,       // 73 -
    LX_ROP_PAT | LX_ROP_SRC | LX_ROP_DST,       // 74 -
    LX_ROP_PAT | LX_ROP_SRC | LX_ROP_DST,       // 75 -
    LX_ROP_PAT | LX_ROP_SRC | LX_ROP_DST,       // 76 -
    LX_ROP_SRC | LX_ROP_DST,                    // 77 - DSan
    LX_ROP_PAT | LX_ROP_SRC | LX_ROP_DST,       // 78 -
    LX_ROP_PAT | LX_ROP_SRC | LX_ROP_DST,       // 79 -
    LX_ROP_PAT | LX_ROP_SRC | LX_ROP_DST,       // 7A -
    LX_ROP_PAT | LX_ROP_SRC | LX_ROP_DST,       // 7B -
    LX_ROP_PAT | LX_ROP_SRC | LX_ROP_DST,       // 7C -
    LX_ROP_PAT | LX_ROP_SRC | LX_ROP_DST,       // 7D -
    LX_ROP_PAT | LX_ROP_SRC | LX_ROP_DST,       // 7E -
    LX_ROP_PAT | LX_ROP_SRC | LX_ROP_DST,       // 7F -

    LX_ROP_PAT | LX_ROP_SRC | LX_ROP_DST,       // 80 -
    LX_ROP_PAT | LX_ROP_SRC | LX_ROP_DST,       // 81 -
    LX_ROP_PAT | LX_ROP_SRC | LX_ROP_DST,       // 82 -
    LX_ROP_PAT | LX_ROP_SRC | LX_ROP_DST,       // 83 -
    LX_ROP_PAT | LX_ROP_SRC | LX_ROP_DST,       // 84 -
    LX_ROP_PAT | LX_ROP_SRC | LX_ROP_DST,       // 85 -
    LX_ROP_PAT | LX_ROP_SRC | LX_ROP_DST,       // 86 -
    LX_ROP_PAT | LX_ROP_SRC | LX_ROP_DST,       // 87 -
    LX_ROP_SRC | LX_ROP_DST,                    // 88 - DSa
    LX_ROP_PAT | LX_ROP_SRC | LX_ROP_DST,       // 89 -
    LX_ROP_PAT | LX_ROP_SRC | LX_ROP_DST,       // 8A -
    LX_ROP_PAT | LX_ROP_SRC | LX_ROP_DST,       // 8B -
    LX_ROP_PAT | LX_ROP_SRC | LX_ROP_DST,       // 8C -
    LX_ROP_PAT | LX_ROP_SRC | LX_ROP_DST,       // 8D -
    LX_ROP_PAT | LX_ROP_SRC | LX_ROP_DST,       // 8E -
    LX_ROP_PAT | LX_ROP_SRC | LX_ROP_DST,       // 8F -

    LX_ROP_PAT | LX_ROP_SRC | LX_ROP_DST,       // 90 -
    LX_ROP_PAT | LX_ROP_SRC | LX_ROP_DST,       // 91 -
    LX_ROP_PAT | LX_ROP_SRC | LX_ROP_DST,       // 92 -
    LX_ROP_PAT | LX_ROP_SRC | LX_ROP_DST,       // 93 -
    LX_ROP_PAT | LX_ROP_SRC | LX_ROP_DST,       // 94 -
    LX_ROP_PAT | LX_ROP_SRC | LX_ROP_DST,       // 95 -
    LX_ROP_PAT | LX_ROP_SRC | LX_ROP_DST,       // 96 -
    LX_ROP_PAT | LX_ROP_SRC | LX_ROP_DST,       // 97 -
    LX_ROP_PAT | LX_ROP_SRC | LX_ROP_DST,       // 98 -
    LX_ROP_SRC | LX_ROP_DST,                    // 99 - DSxn
    LX_ROP_PAT | LX_ROP_SRC | LX_ROP_DST,       // 9A -
    LX_ROP_PAT | LX_ROP_SRC | LX_ROP_DST,       // 9B -
    LX_ROP_PAT | LX_ROP_SRC | LX_ROP_DST,       // 9C -
    LX_ROP_PAT | LX_ROP_SRC | LX_ROP_DST,       // 9D -
    LX_ROP_PAT | LX_ROP_SRC | LX_ROP_DST,       // 9E -
    LX_ROP_PAT | LX_ROP_SRC | LX_ROP_DST,       // 9F -

    LX_ROP_PAT | LX_ROP_DST,                    // A0 - DPa
    LX_ROP_PAT | LX_ROP_SRC | LX_ROP_DST,       // A1 -
    LX_ROP_PAT | LX_ROP_SRC | LX_ROP_DST,       // A2 -
    LX_ROP_PAT | LX_ROP_SRC | LX_ROP_DST,       // A3 -
    LX_ROP_PAT | LX_ROP_SRC | LX_ROP_DST,       // A4 -
    LX_ROP_PAT | LX_ROP_DST,                    // A5 - PDxn
    LX_ROP_PAT | LX_ROP_SRC | LX_ROP_DST,       // A6 -
    LX_ROP_PAT | LX_ROP_SRC | LX_ROP_DST,       // A7 -
    LX_ROP_PAT | LX_ROP_SRC | LX_ROP_DST,       // A8 -
    LX_ROP_PAT | LX_ROP_SRC | LX_ROP_DST,       // A9 -
    LX_ROP_DST,                                 // AA - D
    LX_ROP_PAT | LX_ROP_SRC | LX_ROP_DST,       // AB -
    LX_ROP_PAT | LX_ROP_SRC | LX_ROP_DST,       // AC -
    LX_ROP_PAT | LX_ROP_SRC | LX_ROP_DST,       // AD -
    LX_ROP_PAT | LX_ROP_SRC | LX_ROP_DST,       // AE -
    LX_ROP_PAT | LX_ROP_DST,                    // AF - DPno

    LX_ROP_PAT | LX_ROP_SRC | LX_ROP_DST,       // B0 -
    LX_ROP_PAT | LX_ROP_SRC | LX_ROP_DST,       // B1 -
    LX_ROP_PAT | LX_ROP_SRC | LX_ROP_DST,       // B2 -
    LX_ROP_PAT | LX_ROP_SRC | LX_ROP_DST,       // B3 -
    LX_ROP_PAT | LX_ROP_SRC | LX_ROP_DST,       // B4 -
    LX_ROP_PAT | LX_ROP_SRC | LX_ROP_DST,       // B5 -
    LX_ROP_PAT | LX_ROP_SRC | LX_ROP_DST,       // B6 -
    LX_ROP_PAT | LX_ROP_SRC | LX_ROP_DST,       // B7 -
    LX_ROP_PAT | LX_ROP_SRC | LX_ROP_DST,       // B8 -
    LX_ROP_PAT | LX_ROP_SRC | LX_ROP_DST,       // B9 -
    LX_ROP_PAT | LX_ROP_SRC | LX_ROP_DST,       // BA -
    LX_ROP_SRC | LX_ROP_DST,                    // BB - DSno
    LX_ROP_PAT | LX_ROP_SRC | LX_ROP_DST,       // BC -
    LX_ROP_PAT | LX_ROP_SRC | LX_ROP_DST,       // BD -
    LX_ROP_PAT | LX_ROP_SRC | LX_ROP_DST,       // BE -
    LX_ROP_PAT | LX_ROP_SRC | LX_ROP_DST,       // BF -

    LX_ROP_PAT | LX_ROP_SRC,                    // C0 - PSa
    LX_ROP_PAT | LX_ROP_SRC | LX_ROP_DST,       // C1 -
    LX_ROP_PAT | LX_ROP_SRC | LX_ROP_DST,       // C2 -
    LX_ROP_PAT | LX_ROP_SRC,                    // C3 - PSxn
    LX_ROP_PAT | LX_ROP_SRC | LX_ROP_DST,       // C4 -
    LX_ROP_PAT | LX_ROP_SRC | LX_ROP_DST,       // C5 -
    LX_ROP_PAT | LX_ROP_SRC | LX_ROP_DST,       // C6 -
    LX_ROP_PAT | LX_ROP_SRC | LX_ROP_DST,       // C7 -
    LX_ROP_PAT | LX_ROP_SRC | LX_ROP_DST,       // C8 -
    LX_ROP_PAT | LX_ROP_SRC | LX_ROP_DST,       // C9 -
    LX_ROP_PAT | LX_ROP_SRC | LX_ROP_DST,       // CA -
    LX_ROP_PAT | LX_ROP_SRC | LX_ROP_DST,       // CB -
    LX_ROP_SRC,                                 // CC - S
    LX_ROP_PAT | LX_ROP_SRC | LX_ROP_DST,       // CD -
    LX_ROP_PAT | LX_ROP_SRC | LX_ROP_DST,       // CE -
    LX_ROP_PAT | LX_ROP_SRC,                    // CF - SPno

    LX_ROP_PAT | LX_ROP_SRC | LX_ROP_DST,       // D0 -
    LX_ROP_PAT | LX_ROP_SRC | LX_ROP_DST,       // D1 -
    LX_ROP_PAT | LX_ROP_SRC | LX_ROP_DST,       // D2 -
    LX_ROP_PAT | LX_ROP_SRC | LX_ROP_DST,       // D3 -
    LX_ROP_PAT | LX_ROP_SRC | LX_ROP_DST,       // D4 -
    LX_ROP_PAT | LX_ROP_SRC | LX_ROP_DST,       // D5 -
    LX_ROP_PAT | LX_ROP_SRC | LX_ROP_DST,       // D6 -
    LX_ROP_PAT | LX_ROP_SRC | LX_ROP_DST,       // D7 -
    LX_ROP_PAT | LX_ROP_SRC | LX_ROP_DST,       // D8 -
    LX_ROP_PAT | LX_ROP_SRC | LX_ROP_DST,       // D9 -
    LX_ROP_PAT | LX_ROP_SRC | LX_ROP_DST,       // DA -
    LX_ROP_PAT | LX_ROP_SRC | LX_ROP_DST,       // DB -
    LX_ROP_PAT | LX_ROP_SRC | LX_ROP_DST,       // DC -
    LX_ROP_SRC | LX_ROP_DST,                    // DD - SDno
    LX_ROP_PAT | LX_ROP_SRC | LX_ROP_DST,       // DE -
    LX_ROP_PAT | LX_ROP_SRC | LX_ROP_DST,       // DF -

    LX_ROP_PAT | LX_ROP_SRC | LX_ROP_DST,       // E0 -
    LX_ROP_PAT | LX_ROP_SRC | LX_ROP_DST,       // E1 -
    LX_ROP_PAT | LX_ROP_SRC | LX_ROP_DST,       // E2 -
    LX_ROP_PAT | LX_ROP_SRC | LX_ROP_DST,       // E3 -
    LX_ROP_PAT | LX_ROP_SRC | LX_ROP_DST,       // E4 -
    LX_ROP_PAT | LX_ROP_SRC | LX_ROP_DST,       // E5 -
    LX_ROP_PAT | LX_ROP_SRC | LX_ROP_DST,       // E6 -
    LX_ROP_PAT | LX_ROP_SRC | LX_ROP_DST,       // E7 -
    LX_ROP_PAT | LX_ROP_SRC | LX_ROP_DST,       // E8 -
    LX_ROP_PAT | LX_ROP_SRC | LX_ROP_DST,       // E9 -
    LX_ROP_PAT | LX_ROP_SRC | LX_ROP_DST,       // EA -
    LX_ROP_PAT | LX_ROP_SRC | LX_ROP_DST,       // EB -
    LX_ROP_PAT | LX_ROP_SRC | LX_ROP_DST,       // EC -
    LX_ROP_PAT | LX_ROP_SRC | LX_ROP_DST,       // ED -
    LX_ROP_SRC | LX_ROP_DST,                    // EE - DSo
    LX_ROP_PAT | LX_ROP_SRC | LX_ROP_DST,       // EF -

    LX_ROP_PAT,                                 // F0 - P
    LX_ROP_PAT | LX_ROP_SRC | LX_ROP_DST,       // F1 -
    LX_ROP_PAT | LX_ROP_SRC | LX_ROP_DST,       // F2 -
    LX_ROP_PAT | LX_ROP_SRC,                    // F3 - PSno
    LX_ROP_PAT | LX_ROP_SRC | LX_ROP_DST,       // F4 -
    LX_ROP_PAT | LX_ROP_DST,                    // F5 - PDno
    LX_ROP_PAT | LX_ROP_SRC | LX_ROP_DST,       // F6 -
    LX_ROP_PAT | LX_ROP_SRC | LX_ROP_DST,       // F7 -
    LX_ROP_PAT | LX_ROP_SRC | LX_ROP_DST,       // F8 -
    LX_ROP_PAT | LX_ROP_SRC | LX_ROP_DST,       // F9 -
    LX_ROP_PAT | LX_ROP_DST,                    // FA - DPo
    LX_ROP_PAT | LX_ROP_SRC | LX_ROP_DST,       // FB -
    LX_ROP_PAT | LX_ROP_SRC,                    // FC - PSo
    LX_ROP_PAT | LX_ROP_SRC | LX_ROP_DST,       // FD -
    LX_ROP_PAT | LX_ROP_SRC | LX_ROP_DST,       // FE -
    0,                                          // FF - 1
};

#endif