// Copyright (c) 2006 Advanced Micro Devices ("AMD").
//
// All Rights Reserved.  Unpublished rights reserved under the 
// copyright laws of the United States of America, other countries 
// and international treaties.  The software is provided without 
// fee.  Permission to use, copy, store, modify, disclose, transmit 
// or distribute the software is granted, provided that this 
// copyright notice must appear in any copy, modification, 
// disclosure, transmission or distribution of the software.
//
// AMD retains all ownership, copyright, trade secret and 
// proprietary rights in the software. THIS SOFTWARE HAS BEEN 
// PROVIDED "AS IS," WITHOUT EXPRESS OR IMPLIED WARRANTY INCLUDING, 
// WITHOUT LIMITATION, IMPLIED WARRANTIES OF MERCHANTABILITY, 
// FITNESS FOR A PARTICULAR USE AND NON-INFRINGEMENT.
//
// AMD does not assume or authorize any other person to assume for 
// it any liability in connection with the Software. AMD SHALL NOT 
// BE LIABLE TO COMPANY, OR ANY THIRD PARTY, IN CONTRACT, TORT, 
// WARRANTY, STRICT LIABILITY, OR OTHERWISE FOR ANY DIRECT DAMAGES, 
// OR FOR ANY SPECIAL, INDIRECT, INCIDENTAL OR CONSEQUENTIAL 
// DAMAGES, INCLUDING BUT NOT LIMITED TO, BUSINESS INTERRUPTION, 
// LOST PROFITS OR GOODWILL, OR LOSS OF INFORMATION EVEN IF AMD IS 
// ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.
//
#pragma once
#include "afxwin.h"

// DEFINITIONS FOR GENERALIZED TIMING FORMULA
// These are technically configurable per the VESA standards, but we
// are using the default values.
//  
#define NUM_VSYNC_LINES     3.0
#define TGT_VERT_FLYBACK    550.0
#define MIN_V_FRONT_PORCH   13.0
#define ACTUAL_M            300.0
#define ACTUAL_C            30.0
#define CHAR_WIDTH          8.0
#define HSYNC_PERCENTAGE    0.08

// CLX_GTFDlg dialog
//
class CLX_GTFDlg : public CDialog
{
// Construction
public:
	CLX_GTFDlg(CWnd* pParent = NULL);	// standard constructor

// Dialog Data
	enum { IDD = IDD_LX_GTF_DIALOG };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support

// Implementation
protected:
	HICON m_hIcon;

	// Generated message map functions
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	DECLARE_MESSAGE_MAP()
public:
    afx_msg void OnBnClickedGenerate();
    virtual void OnOK();
    DWORD m_panelWidth;
    DWORD m_panelHeight;
    DWORD m_panelRefresh;
    BOOL m_panelBusWidth;
    CButton m_generateButton;
    BOOL m_simultaneous;
    BOOL m_negHsync;
    BOOL m_negVsync;
};
#pragma once

// CDisplayTimings dialog
//
class CDisplayTimings : public CDialog
{
	DECLARE_DYNAMIC(CDisplayTimings)

public:
	CDisplayTimings(CWnd* pParent = NULL);   // standard constructor
	virtual ~CDisplayTimings();

    CFont m_font;
    bool m_fontCreated;

// Dialog Data
	enum { IDD = IDD_GENERATED_TIMINGS };

protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

	DECLARE_MESSAGE_MAP()
public:
    virtual BOOL OnInitDialog();
    CString m_generatedTimings;
    CEdit m_textEdit;    
};
