//
// <LIC_AMD_STD>
// Copyright (C) <years> Advanced Micro Devices, Inc.  All Rights Reserved.
// </LIC_AMD_STD>
//
// <CTL_AMD_STD>
// </CTL_AMD_STD>
//
// <DOC_AMD_STD>
// Debug display code.
// </DOC_AMD_STD>
//

#if DBG

#include <devioctl.h>
#include <miniport.h>
#include "ntddvdeo.h"
#include <video.h>
#include <stdio.h>
#include <stdarg.h>
#include "lxdrv.h"
#include "debug.h"

ULONG DebugLevel = 500;

unsigned long DbgPrint(char *,...);

/////////////////////////////////////////////////////////////////////////
// DebugPrint
//
// Takes a debug level and a variable argument list.  The list is
// formatted into a string.  The string is then sent to COM2 like
// traditional NT output if the severity level is high enough.
//
void DebugPrint (ULONG DebugPrintLevel, PCHAR DebugMessage, ...)
{
	va_list ap;

	va_start(ap, DebugMessage);

	if(DebugPrintLevel >= DebugLevel)
    {
		char buffer[256];
		char *outPtr;
		int  len;
		int prefixLen;

		outPtr = &buffer[0];	

		while(*DebugMessage == '\n')
			*outPtr++ = *DebugMessage++;

		prefixLen = strlen(DBG_STRING);
		memcpy(outPtr, DBG_STRING, prefixLen);
		outPtr += prefixLen;

		len = vsprintf(outPtr, DebugMessage, ap);
		outPtr += len;

		if(outPtr[-1] != '\n')
			*outPtr++ = '\n';

		*outPtr = '\0';

		/* SEND OUT DEBUG MESSAGE */

		DbgPrint(buffer);
	}

	va_end(ap);
}

#endif /*DBG*/
